//----------------------------------------------------------------------------
//  Project BIOSData
//  Zeal SoftStudio
//  Copyright (c) 2003, Zeal SoftStudio. All Rights Reserved.
//
//  SUBSYSTEM:    BIOSData Application
//  FILE:         biosdtap.cpp
//  AUTHOR:       Hai Li
//
//  OVERVIEW
//  ~~~~~~~~
//  Source file for implementation of TBIOSDataApp (TApplication).
//
//----------------------------------------------------------------------------

#include <owl/pch.h>

#include <owl/buttonga.h>
#include <owl/statusba.h>
#include <classlib/cmdline.h>
#include <winsys/registry.h>
#include <stdio.h>

#include "biosdtap.h"
#include "biosdtdc.h"                        // Definition of client class.


//{{TBIOSDataApp Implementation}}


//
// Build a response table for all messages/commands handled
// by the application.
//
DEFINE_RESPONSE_TABLE1(TBIOSDataApp, TApplication)
//{{TBIOSDataAppRSP_TBL_BEGIN}}
  EV_COMMAND(CM_HELPABOUT, CmHelpAbout),
//{{TBIOSDataAppRSP_TBL_END}}
END_RESPONSE_TABLE;


//--------------------------------------------------------
// TBIOSDataApp
//
TBIOSDataApp::TBIOSDataApp() : TApplication("BIOSData Sample")
{

  // INSERT>> Your constructor code here.
}


TBIOSDataApp::~TBIOSDataApp()
{
  // INSERT>> Your destructor code here.
}


//--------------------------------------------------------
// TBIOSDataApp
// ~~~~~
// Application intialization.
//
void TBIOSDataApp::InitMainWindow()
{
  if (nCmdShow != SW_HIDE)
    nCmdShow = (nCmdShow != SW_SHOWMINNOACTIVE) ? SW_SHOWNORMAL : nCmdShow;

  TSDIDecFrame* frame = new TSDIDecFrame(0, GetName(), 0, true);
  frame->SetFlag(wfShrinkToClient);

  // Assign ICON w/ this application.
  //
  frame->SetIcon(this, IDI_SDIAPPLICATION);
  frame->SetIconSm(this, IDI_SDIAPPLICATION);


  TStatusBar* sb = new TStatusBar(frame, TGadget::Recessed,
                                  TStatusBar::CapsLock        |
                                  TStatusBar::NumLock         |
                                  TStatusBar::ScrollLock);
  frame->Insert(*sb, TDecoratedFrame::Bottom);

  SetMainWindow(frame);

}


//--------------------------------------------------------
// TBIOSDataApp
// ~~~~~
// Application instance initialization.
//
void TBIOSDataApp::InitInstance()
{
  TApplication::InitInstance();

  ProcessCmdLine(lpCmdLine);
}


//--------------------------------------------------------
// TBIOSDataApp
// ~~~~~
// Process command line parameters.
//
void TBIOSDataApp::ProcessCmdLine(char * CmdLine)
{
  TCmdLine cmd(CmdLine);

  while (cmd.Kind != TCmdLine::Done) {
    if (cmd.Kind == TCmdLine::Option) {
      if (strnicmp(cmd.Token, "unregister", cmd.TokenLen) == 0) {
        UnRegisterInfo();
        return;
      }
    }
    cmd.NextToken();
  }

  RegisterInfo();
}


//--------------------------------------------------------
// TBIOSDataApp
// ~~~~~
// Register application info.
//
void TBIOSDataApp::RegisterInfo()
{
  TAPointer<char> buffer = new char[_MAX_PATH];

  GetModuleFileName(buffer, _MAX_PATH);

  TRegKey(TRegKey::ClassesRoot, "BIOSData.Application\\DefaultIcon").SetDefValue(0, REG_SZ, buffer, strlen(buffer));
  strcat(buffer, ",1");
}


//--------------------------------------------------------
// TBIOSDataApp
// ~~~~~
// Unregister application info.
//
void TBIOSDataApp::UnRegisterInfo()
{
  TAPointer<char> buffer = new char[_MAX_PATH];

  GetModuleFileName(buffer, _MAX_PATH);

  TRegKey(TRegKey::ClassesRoot, "BIOSData.Application").DeleteKey("DefaultIcon");
  TRegKey(TRegKey::ClassesRoot, "BIOSData.Document.1").DeleteKey("DefaultIcon");

  TRegKey::ClassesRoot.DeleteKey("BIOSData.Application");
}



//{{TSDIDecFrame Implementation}}


TSDIDecFrame::TSDIDecFrame(TWindow* parent, const char far* title, TWindow* clientWnd, bool trackMenuSelection, TModule* module)
:
  TDecoratedFrame(parent, title, !clientWnd ? new TBIOSDataDlgClient(0) : clientWnd, trackMenuSelection, module)
{
  // INSERT>> Your constructor code here.

}


TSDIDecFrame::~TSDIDecFrame()
{
  // INSERT>> Your destructor code here.

}


void TSDIDecFrame::SetupWindow()
{
  TDecoratedFrame::SetupWindow();
  TRect  r;
  GetWindowRect(r);

  r.bottom += 30;
  SetWindowPos(0, r, SWP_NOZORDER | SWP_NOMOVE);

  // INSERT>> Your code here.

}


//--------------------------------------------------------
// TBIOSDataApp
// ~~~~~~~~~~~
// Menu Help About BIOSData command
//
void TBIOSDataApp::CmHelpAbout()
{
}



int OwlMain(int , char* [])
{
  TBIOSDataApp   app;
  return app.Run();
}
