//----------------------------------------------------------------------------
//  Project BIOSData
//  Zeal SoftStudio
//  Copyright (c) 2003, Zeal SoftStudio. All Rights Reserved.
//
//  SUBSYSTEM:    BIOSData Application
//  FILE:         biosdtap.h
//  AUTHOR:       Hai Li
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TBIOSDataApp (TApplication).
//
//----------------------------------------------------------------------------
#if !defined(biosdtap_h)              // Sentry, use file only if it's not already included.
#define biosdtap_h

#include <owl/controlb.h>
#include <owl/docking.h>
#include <owl/mailer.h>
#include <owl/opensave.h>


#include "biosdtap.rh"            // Definition of all resources.


//
// FrameWindow must be derived to override Paint for Preview and Print.
//
//{{TDecoratedFrame = TSDIDecFrame}}
class TSDIDecFrame : public TDecoratedFrame {
  public:
    TSDIDecFrame(TWindow* parent, const char far* title, TWindow* clientWnd, bool trackMenuSelection = false, TModule* module = 0);
    ~TSDIDecFrame();

//{{TBIOSDataAppVIRTUAL_BEGIN}}
  public:
    virtual void SetupWindow();
//{{TBIOSDataAppVIRTUAL_END}}
};    //{{TSDIDecFrame}}


//{{TApplication = TBIOSDataApp}}
class TBIOSDataApp : public TApplication {
  private:

    void ProcessCmdLine(char * CmdLine);
    void RegisterInfo();
    void UnRegisterInfo();

  public:
    TBIOSDataApp();
    virtual ~TBIOSDataApp();

    THarbor*        ApxHarbor;

//{{TBIOSDataAppVIRTUAL_BEGIN}}
  public:
    virtual void InitMainWindow();
    virtual void InitInstance();
//{{TBIOSDataAppVIRTUAL_END}}

//{{TBIOSDataAppRSP_TBL_BEGIN}}
  protected:
    void CmHelpAbout();
//{{TBIOSDataAppRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TBIOSDataApp);
};    //{{TBIOSDataApp}}


#endif  // biosdtap_h sentry.
