//----------------------------------------------------------------------------
//  Project Map
//  Zeal SoftStudio
//  Copyright (c) 2003, Zeal SoftStudio. All Rights Reserved.
//
//  SUBSYSTEM:    Map Application
//  FILE:         mapapp.h
//  AUTHOR:       Hai Li
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TMapApp (TApplication).
//
//----------------------------------------------------------------------------
#if !defined(mapapp_h)              // Sentry, use file only if it's not already included.
#define mapapp_h

#include <owl/controlb.h>
#include <owl/docking.h>
#include <owl/mailer.h>
#include <owl/opensave.h>


#include "mapapp.rh"            // Definition of all resources.


//
// FrameWindow must be derived to override Paint for Preview and Print.
//
//{{TDecoratedFrame = TSDIDecFrame}}
class TSDIDecFrame : public TDecoratedFrame {
  public:
    TSDIDecFrame(TWindow* parent, const char far* title, TWindow* clientWnd, bool trackMenuSelection = false, TModule* module = 0);
    ~TSDIDecFrame();

//{{TMapAppVIRTUAL_BEGIN}}
  public:
    virtual void SetupWindow();
//{{TMapAppVIRTUAL_END}}
};    //{{TSDIDecFrame}}


//{{TApplication = TMapApp}}
class TMapApp : public TApplication {
  private:

    void ProcessCmdLine(char * CmdLine);
    void RegisterInfo();
    void UnRegisterInfo();

  public:
    TMapApp();
    virtual ~TMapApp();

    THarbor*        ApxHarbor;

//{{TMapAppVIRTUAL_BEGIN}}
  public:
    virtual void InitMainWindow();
    virtual void InitInstance();
//{{TMapAppVIRTUAL_END}}

//{{TMapAppRSP_TBL_BEGIN}}
  protected:
    void CmHelpAbout();
//{{TMapAppRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TMapApp);
};    //{{TMapApp}}


#endif  // mapapp_h sentry.
