//----------------------------------------------------------------------------
//  Project Map
//  Zeal SoftStudio
//  Copyright (c) 2003, Zeal SoftStudio. All Rights Reserved.
//
//  SUBSYSTEM:    Map Application
//  FILE:         mpdlgcln.cpp
//  AUTHOR:       Hai Li
//
// Map sample shows how to call the maMapPhysToLinear function to map the memory.
// www.zealsoftstudio.com
// support@zealsoft.com
//
//  OVERVIEW
//  ~~~~~~~~
//  Source file for implementation of TMapDlgClient (TDialog).
//
//----------------------------------------------------------------------------

#include <owl/pch.h>

#include "mapapp.h"
#include "mpdlgcln.h"
#include "MemAcc.h"

//
// Build a response table for all messages/commands handled by the application.
//
DEFINE_RESPONSE_TABLE1(TMapDlgClient, TDialog)
//{{TMapDlgClientRSP_TBL_BEGIN}}
  EV_BN_CLICKED(IDOK, BNClicked),
//{{TMapDlgClientRSP_TBL_END}}
END_RESPONSE_TABLE;


//{{TMapDlgClient Implementation}}


//--------------------------------------------------------
// TMapDlgClient
// ~~~~~~~~~~
// Construction/Destruction handling.
//
TMapDlgClient::TMapDlgClient(TWindow* parent, TResId resId, TModule* module)
:
  TDialog(parent, resId, module)
{
  // INSERT>> Your constructor code here.
}


TMapDlgClient::~TMapDlgClient()
{
  Destroy();

  // INSERT>> Your destructor code here.
}

void TMapDlgClient::BNClicked()
{
  // INSERT>> Your code here.
    char sError[255];

    // Open the library
    if(!maOpenLibrary())
	{
        maGetLastState(sError);
        MessageBox(sError, "Error", MB_ICONSTOP);
        return;
    }

    HANDLE h;
    LPSTR pszAddr;

    // Map the physical address
    pszAddr = (LPSTR)maMapPhysToLinear(0xFFFF5, 10, &h);
    if(!pszAddr)
	{
        maGetLastState(sError);
        MessageBox(sError, "Error", MB_ICONSTOP);
        return;
    }

    // Copy the BIOS date string from the linear address
    char s[256];
    strcpy(s, "BIOS date:");
    strcat(s, pszAddr);
    SetDlgItemText(IDC_BIOSDATE,  s);

    // Unmap the address
    maUnmapPhysicalMemory(h, pszAddr);

    // Close the library
    maCloseLibrary();
}

