//----------------------------------------------------------------------------
//  Project MemTest
//  Zeal SoftStudio
//  Copyright  (c) Zeal SoftStudio. All Rights Reserved.
//
//  SUBSYSTEM:    MemTest Application
//  FILE:         mmtstapp.cpp
//  AUTHOR:       Hai Li
//
//  OVERVIEW
//  ~~~~~~~~
//  Source file for implementation of TMemTestApp (TApplication).
//
//----------------------------------------------------------------------------

#include <owl/pch.h>

#include <owl/buttonga.h>
#include <owl/statusba.h>
#include <classlib/cmdline.h>
#include <winsys/registry.h>
#include <stdio.h>

#include "mmtstapp.h"
#include "mmtstdlc.h"                        // Definition of client class.


//{{TMemTestApp Implementation}}


//
// Build a response table for all messages/commands handled
// by the application.
//
DEFINE_RESPONSE_TABLE1(TMemTestApp, TApplication)
//{{TMemTestAppRSP_TBL_BEGIN}}
  EV_COMMAND(CM_HELPABOUT, CmHelpAbout),
//{{TMemTestAppRSP_TBL_END}}
END_RESPONSE_TABLE;


//--------------------------------------------------------
// TMemTestApp
//
TMemTestApp::TMemTestApp() : TApplication("MemTest Sample")
{

  // INSERT>> Your constructor code here.
}


TMemTestApp::~TMemTestApp()
{
  // INSERT>> Your destructor code here.
}


//--------------------------------------------------------
// TMemTestApp
// ~~~~~
// Application intialization.
//
void TMemTestApp::InitMainWindow()
{
  if (nCmdShow != SW_HIDE)
    nCmdShow = (nCmdShow != SW_SHOWMINNOACTIVE) ? SW_SHOWNORMAL : nCmdShow;

  TSDIDecFrame* frame = new TSDIDecFrame(0, GetName(), 0, true);
  frame->SetFlag(wfShrinkToClient);

  // Assign ICON w/ this application.
  //
  frame->SetIcon(this, IDI_SDIAPPLICATION);
  frame->SetIconSm(this, IDI_SDIAPPLICATION);


  TStatusBar* sb = new TStatusBar(frame, TGadget::Recessed,
                                  TStatusBar::CapsLock        |
                                  TStatusBar::NumLock         |
                                  TStatusBar::ScrollLock);
  frame->Insert(*sb, TDecoratedFrame::Bottom);

  SetMainWindow(frame);

}


//--------------------------------------------------------
// TMemTestApp
// ~~~~~
// Application instance initialization.
//
void TMemTestApp::InitInstance()
{
  TApplication::InitInstance();

  ProcessCmdLine(lpCmdLine);
}


//--------------------------------------------------------
// TMemTestApp
// ~~~~~
// Process command line parameters.
//
void TMemTestApp::ProcessCmdLine(char * CmdLine)
{
  TCmdLine cmd(CmdLine);

  while (cmd.Kind != TCmdLine::Done) {
    if (cmd.Kind == TCmdLine::Option) {
      if (strnicmp(cmd.Token, "unregister", cmd.TokenLen) == 0) {
        UnRegisterInfo();
        return;
      }
    }
    cmd.NextToken();
  }

  RegisterInfo();
}


//--------------------------------------------------------
// TMemTestApp
// ~~~~~
// Register application info.
//
void TMemTestApp::RegisterInfo()
{
  TAPointer<char> buffer = new char[_MAX_PATH];

  GetModuleFileName(buffer, _MAX_PATH);

  TRegKey(TRegKey::ClassesRoot, "MemTest.Application\\DefaultIcon").SetDefValue(0, REG_SZ, buffer, strlen(buffer));
  strcat(buffer, ",1");
}


//--------------------------------------------------------
// TMemTestApp
// ~~~~~
// Unregister application info.
//
void TMemTestApp::UnRegisterInfo()
{
  TAPointer<char> buffer = new char[_MAX_PATH];

  GetModuleFileName(buffer, _MAX_PATH);

  TRegKey(TRegKey::ClassesRoot, "MemTest.Application").DeleteKey("DefaultIcon");
  TRegKey(TRegKey::ClassesRoot, "MemTest.Document.1").DeleteKey("DefaultIcon");

  TRegKey::ClassesRoot.DeleteKey("MemTest.Application");
}



//{{TSDIDecFrame Implementation}}


TSDIDecFrame::TSDIDecFrame(TWindow* parent, const char far* title, TWindow* clientWnd, bool trackMenuSelection, TModule* module)
:
  TDecoratedFrame(parent, title, !clientWnd ? new TMemTestDlgClient(0) : clientWnd, trackMenuSelection, module)
{
  // INSERT>> Your constructor code here.

}


TSDIDecFrame::~TSDIDecFrame()
{
  // INSERT>> Your destructor code here.

}


void TSDIDecFrame::SetupWindow()
{
  TDecoratedFrame::SetupWindow();
  TRect  r;
  GetWindowRect(r);

  r.bottom += 30;
  SetWindowPos(0, r, SWP_NOZORDER | SWP_NOMOVE);

  // INSERT>> Your code here.

}


//--------------------------------------------------------
// TMemTestApp
// ~~~~~~~~~~~
// Menu Help About MemTest command
//
void TMemTestApp::CmHelpAbout()
{
}



int OwlMain(int , char* [])
{
  TMemTestApp   app;
  return app.Run();
}
