//----------------------------------------------------------------------------
//  Project MemTest
//  Zeal SoftStudio
//  Copyright  (c) Zeal SoftStudio. All Rights Reserved.
//
//  SUBSYSTEM:    MemTest Application
//  FILE:         mmtstapp.h
//  AUTHOR:       Hai Li
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TMemTestApp (TApplication).
//
//----------------------------------------------------------------------------
#if !defined(mmtstapp_h)              // Sentry, use file only if it's not already included.
#define mmtstapp_h

#include <owl/controlb.h>
#include <owl/docking.h>
#include <owl/mailer.h>
#include <owl/opensave.h>


#include "mmtstapp.rh"            // Definition of all resources.


//
// FrameWindow must be derived to override Paint for Preview and Print.
//
//{{TDecoratedFrame = TSDIDecFrame}}
class TSDIDecFrame : public TDecoratedFrame {
  public:
    TSDIDecFrame(TWindow* parent, const char far* title, TWindow* clientWnd, bool trackMenuSelection = false, TModule* module = 0);
    ~TSDIDecFrame();

//{{TMemTestAppVIRTUAL_BEGIN}}
  public:
    virtual void SetupWindow();
//{{TMemTestAppVIRTUAL_END}}
};    //{{TSDIDecFrame}}


//{{TApplication = TMemTestApp}}
class TMemTestApp : public TApplication {
  private:

    void ProcessCmdLine(char * CmdLine);
    void RegisterInfo();
    void UnRegisterInfo();

  public:
    TMemTestApp();
    virtual ~TMemTestApp();

    THarbor*        ApxHarbor;

//{{TMemTestAppVIRTUAL_BEGIN}}
  public:
    virtual void InitMainWindow();
    virtual void InitInstance();
//{{TMemTestAppVIRTUAL_END}}

//{{TMemTestAppRSP_TBL_BEGIN}}
  protected:
    void CmHelpAbout();
//{{TMemTestAppRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TMemTestApp);
};    //{{TMemTestApp}}


#endif  // mmtstapp_h sentry.
