//----------------------------------------------------------------------------
//  Project MemTest
//  Zeal SoftStudio
//  Copyright  (c) Zeal SoftStudio. All Rights Reserved.
//
//  SUBSYSTEM:    MemTest Application
//  FILE:         mmtstdlc.cpp
//  AUTHOR:       Hai Li
//
// MemTest sample shows how to read or write PC memory.
// www.zealsoftstudio.com
// support@zealsoft.com
//
//  OVERVIEW
//  ~~~~~~~~
//  Source file for implementation of TMemTestDlgClient (TDialog).
//
//----------------------------------------------------------------------------

#include <owl/pch.h>

#include "mmtstapp.h"
#include "mmtstdlc.h"
#include "MemAcc.h"
#include <stdio.h>

//
// Build a response table for all messages/commands handled by the application.
//
DEFINE_RESPONSE_TABLE1(TMemTestDlgClient, TDialog)
//{{TMemTestDlgClientRSP_TBL_BEGIN}}
  EV_BN_CLICKED(IDOK, BNClicked),
  EV_BN_CLICKED(IDC_WRITE, WriteClicked),
//{{TMemTestDlgClientRSP_TBL_END}}
END_RESPONSE_TABLE;


//{{TMemTestDlgClient Implementation}}


//--------------------------------------------------------
// TMemTestDlgClient
// ~~~~~~~~~~
// Construction/Destruction handling.
//
TMemTestDlgClient::TMemTestDlgClient(TWindow* parent, TResId resId, TModule* module)
:
  TDialog(parent, resId, module)
{
  // INSERT>> Your constructor code here.
}


TMemTestDlgClient::~TMemTestDlgClient()
{
  Destroy();

  // INSERT>> Your destructor code here.
}

void TMemTestDlgClient::BNClicked()
{
  // INSERT>> Your code here.
	DWORD dwAddr;
   char sAddr[255];

   GetDlgItemText(IDC_ADDR, sAddr, 255);
	sscanf(sAddr, "%x", &dwAddr);

    char sError[255];

    // Open the library
    if(!maOpenLibrary())
	{
        maGetLastState(sError);
        MessageBox(sError, "Error", MB_ICONSTOP);
        return;
    }

	HANDLE h;
	PBYTE p;

    // Map the physical address
    p = (PBYTE)maMapPhysToLinear(dwAddr, 256, &h);
    if(!p)
	{
        maGetLastState(sError);
        MessageBox(sError, "Error", MB_ICONSTOP);
        return;
    }

    // Read 256 bytes
	char s[10], sData[1024];
	sData[0] = 0;
    for(int i = 0; i < 256; i++)
	{
		wsprintf(s, "%02x ", p[i]);
		strcat(sData, s);
		if(i % 16 == 15)
			strcat(sData, "\r\n");
		SetDlgItemText(IDC_EDIT2, sData);
	}

    // Unmap the address
    maUnmapPhysicalMemory(h, p);

    // Close the library
    maCloseLibrary();
}

void TMemTestDlgClient::WriteClicked()
{
	DWORD dwAddr;
    char sAddr[255];

   GetDlgItemText(IDC_ADDR, sAddr, 255);
	sscanf(sAddr, "%x", &dwAddr);

    char sError[255];

    // Open the library
    if(!maOpenLibrary())
	{
        maGetLastState(sError);
        MessageBox(sError, "Error", MB_ICONSTOP);
        return;
    }

	HANDLE h;
	PBYTE p;

    // Map the physical address
    p = (PBYTE)maMapPhysToLinear(dwAddr, 256, &h);
    if(!p)
	{
        maGetLastState(sError);
        MessageBox(sError, "Error", MB_ICONSTOP);
        return;
    }

    // Write 256 bytes
    for(int i = 0; i < 256; i++)
	{
		*(p + i) = i;
	}

    // Unmap the address
    maUnmapPhysicalMemory(h, p);

    // Close the library
    maCloseLibrary();
}
