//----------------------------------------------------------------------------
//  Project PCISample
//  Zeal SoftStudio
//  Copyright (c) 2003 Zeal SoftStudio. All Rights Reserved.
//
//  SUBSYSTEM:    PCISample Application
//  FILE:         pcisampleapp.h
//  AUTHOR:       Hai Li
//
//  OVERVIEW
//  ~~~~~~~~
//  Class definition for TPCISampleApp (TApplication).
//
//----------------------------------------------------------------------------
#if !defined(pcisampleapp_h)              // Sentry, use file only if it's not already included.
#define pcisampleapp_h

#include <owl/controlb.h>
#include <owl/docking.h>
#include <owl/mailer.h>
#include <owl/opensave.h>


#include "pcisampleapp.rh"            // Definition of all resources.


//
// FrameWindow must be derived to override Paint for Preview and Print.
//
//{{TDecoratedFrame = TSDIDecFrame}}
class TSDIDecFrame : public TDecoratedFrame {
  public:
    TSDIDecFrame(TWindow* parent, const char far* title, TWindow* clientWnd, bool trackMenuSelection = false, TModule* module = 0);
    ~TSDIDecFrame();

//{{TPCISampleAppVIRTUAL_BEGIN}}
  public:
    virtual void SetupWindow();
//{{TPCISampleAppVIRTUAL_END}}
};    //{{TSDIDecFrame}}


//{{TApplication = TPCISampleApp}}
class TPCISampleApp : public TApplication {
  private:

    void ProcessCmdLine(char * CmdLine);
    void RegisterInfo();
    void UnRegisterInfo();

  public:
    TPCISampleApp();
    virtual ~TPCISampleApp();

    THarbor*        ApxHarbor;

//{{TPCISampleAppVIRTUAL_BEGIN}}
  public:
    virtual void InitMainWindow();
    virtual void InitInstance();
//{{TPCISampleAppVIRTUAL_END}}

//{{TPCISampleAppRSP_TBL_BEGIN}}
  protected:
    void CmHelpAbout();
//{{TPCISampleAppRSP_TBL_END}}
DECLARE_RESPONSE_TABLE(TPCISampleApp);
};    //{{TPCISampleApp}}


#endif  // pcisampleapp_h sentry.
