//----------------------------------------------------------------------------
//  Project PCISample
//  Zeal SoftStudio
//  Copyright (c) 2003 Zeal SoftStudio. All Rights Reserved.
//
//  SUBSYSTEM:    PCISample Application
//  FILE:         pcisampledlgclient.cpp
//  AUTHOR:       Hai Li
//
// PCI sample shows how to get the base addresses of a PCI device.
// www.zealsoftstudio.com
// support@zealsoft.com
//
//  OVERVIEW
//  ~~~~~~~~
//  Source file for implementation of TPCISampleDlgClient (TDialog).
//
//----------------------------------------------------------------------------

#include <owl/pch.h>

#include "pcisampleapp.h"
#include "pcisampledlgclient.h"
#include "MemAcc.h"
#include "stdio.h"

//
// Build a response table for all messages/commands handled by the application.
//
DEFINE_RESPONSE_TABLE1(TPCISampleDlgClient, TDialog)
//{{TPCISampleDlgClientRSP_TBL_BEGIN}}
  EV_BN_CLICKED(IDOK, BNClicked),
//{{TPCISampleDlgClientRSP_TBL_END}}
END_RESPONSE_TABLE;


//{{TPCISampleDlgClient Implementation}}


//--------------------------------------------------------
// TPCISampleDlgClient
// ~~~~~~~~~~
// Construction/Destruction handling.
//
TPCISampleDlgClient::TPCISampleDlgClient(TWindow* parent, TResId resId, TModule* module)
:
  TDialog(parent, resId, module)
{
  // INSERT>> Your constructor code here.
}


TPCISampleDlgClient::~TPCISampleDlgClient()
{
  Destroy();

  // INSERT>> Your destructor code here.
}

void TPCISampleDlgClient::BNClicked()
{
  // INSERT>> Your code here.
    int i;
    char sError[255];

    char sDeviceID[20], sVendorID[20];
    GetDlgItemText(IDC_DEVICEID, sDeviceID, 20);
    GetDlgItemText(IDC_VENDORID, sVendorID, 20);
    if(strlen(sDeviceID) == 0 || strlen(sVendorID) == 0)
	{
        MessageBox("Please input the DeviceID and VendorID!", "Error", MB_ICONSTOP);
        return;
    }


    // Open the library
    if(!maOpenLibrary())
	{
        maGetLastState(sError);
        MessageBox(sError, "Error", MB_ICONSTOP);
        return;
	}

    BADDR baddrAddress[6];
    int nResult, nIndex;
    WORD VendorID, DeviceID;

    // Enumerate all devices
    nIndex = 0;
	char sResult[5000], s[2000];
   sResult[0] = 0;
    do
	{
		sscanf(sDeviceID, "%x", &DeviceID);
		sscanf(sVendorID, "%x", &VendorID);
      nResult = maGetDeviceBaseAddress(&VendorID,
			            &DeviceID, nIndex, baddrAddress);
        switch(nResult)
		{
        case 1: // A device found
			   sprintf(s, "VendorID: 0x%x DeviceID: 0x%x\r\n", VendorID, DeviceID);
            strcat(sResult, s);
            for(i = 0; i <= 5; i++)
		   	{
			   	if(baddrAddress[i].IOType != 2)
					{
				    	sprintf(s, "   Address(%d): 0x%x - 0x%x\r\n", i, baddrAddress[i].BaseAddress,
					   	baddrAddress[i].BaseAddress + baddrAddress[i].Size - 1);
						strcat(sResult, s);
						strcat(sResult, "      ");
						strcat(sResult, baddrAddress[i].IOType == 1? "Port I/O" : "Memory I/O");
            	   strcat(sResult, "\r\n");
					}
   	      }
      	   strcat(sResult, "\r\n");
      		break;
        case 0: // Error
            maGetLastState(sError);
            strcpy(sResult, "Error :");
            strcat(sResult, sError);
   			break;
        case -1: // No device found
            if(strlen(sResult) == 0)
			{
                strcpy(sResult, "No device found.");
			}
		}
        nIndex = nIndex + 1;
		SetDlgItemText(IDC_RESULT, sResult);
	}
    while(nResult == 1);

    // Close the library
    maCloseLibrary();

}

